<%@ page pageEncoding="UTF-8" %><%/*****************************************************************
* Gridnine AB http://www.gridnine.com
* Project: Ticketbrokerage
* Legal notice: (c) Gridnine AB. All rights reserved.
*****************************************************************/%><%@ page language="java" 
    session="true"
    import="org.opencms.jsp.*"
    import="org.opencms.file.*"
    import="java.util.*"
    import="org.opencms.frontend.templateone.form.*"
    import="org.opencms.i18n.*"
    import="org.opencms.flex.*"
    import="org.opencms.util.*"
%><%!

public static String buildSelectFieldHtml (I_CmsField field) {
	StringBuilder selectHtml = new StringBuilder();
	List<CmsFieldItem> fieldItems = field.getItems();
	if(fieldItems.size() > 0) {	
		selectHtml.append("<select name=\"" + field.getName() + "\">\r\n");
		String label = field.getLabel();
		String firstItem = null;
		try {
			firstItem = (label.indexOf("%%") < 0) ? "" : "<option>" + label.split("%%")[1] + "</option>";
		} catch (Exception e) {}
		if(firstItem != null) selectHtml.append(firstItem);
		for(CmsFieldItem item : fieldItems) {
			selectHtml.append("<option" + (item.isSelected() ? " selected=\"selected\"" : "") + ">" + item.getLabel() + "</option>\r\n");
		}
		selectHtml.append("</select>\r\n");
	}
	return selectHtml.toString();
}

public static String buildTextFieldHtml (I_CmsField field) {
	return "<input class=\"input4\" type=\"text\" name=\"" + field.getName() + "\" value=\"" + field.getValue() + "\">\r\n";
}

public static String buildLabelHtml (I_CmsField field) {
	String readyHtml = "<label for=\"" + field.getName() + "\">" + field.getLabel().split("%%")[0];
	readyHtml = readyHtml + "</label>\r\n"; 
	return readyHtml;
}

public static String buildTextAreaHtml (I_CmsField field) {
	return "<textarea name=\"" + field.getName() + "\">" + field.getValue() + "</textarea>";	
}

public static String buildCheckboxHtml (I_CmsField field) {
    StringBuilder checkboxHtml = new StringBuilder();
    List<CmsFieldItem> fieldItems = field.getItems();

    checkboxHtml.append("<table class=\"inputBlock\">\n\r");
    for (int i=0; i<fieldItems.size();i++) {
        CmsFieldItem curOption = fieldItems.get(i);
        String checked = "";
        //if (curOption.isSelected() || field.isMandatory() && cms.isInitial()) {
        if (curOption.isSelected()) {
            checked = " checked=\"checked\"";
        }
        checkboxHtml.append("<tr>\n\r<td>\n\r");
        checkboxHtml.append("<input type=\"checkbox\" class=\"checkbox\"" + 
                " name=\"" + field.getName() + "\" id=\"" + field.getName() + "[" + i + "]" + 
                "\" value=\"" + curOption.getValue() + "\"" + checked + ">\n\r");
        checkboxHtml.append("</td>\n\r");
        checkboxHtml.append("<td class=\"checkboxOptionLabel\">\n\r");
        checkboxHtml.append(curOption.getLabel());
        checkboxHtml.append("\n\r</td>\n\r</tr>\n\r");
    }
    checkboxHtml.append("</table>");

    return checkboxHtml.toString();
}

public static String buildRadioHtml (I_CmsField field) {
    StringBuilder radioHtml = new StringBuilder();
    List<CmsFieldItem> fieldItems = field.getItems();

    radioHtml.append("<table class=\"inputBlock\">\n\r<tr>\n\r");
    for (int i=0; i<fieldItems.size();i++) {
        CmsFieldItem curOption = fieldItems.get(i);
        String checked = "";
        if (curOption.isSelected()) {
            checked = " checked=\"checked\"";
        }
        radioHtml.append("\n\r<td>\n\r");
        radioHtml.append("<input type=\"radio\" class=\"radio\"" + 
                "name=\"" + field.getName() + "\" id=\"" + field.getName() + "[" + i + "]" + 
                "\" value=\"" + curOption.getValue() + "\"" + checked + ">\n\r");
        radioHtml.append("</td>\n\r");
        radioHtml.append("<td class=\"radioOptionLabel\">\n\r");
        radioHtml.append(curOption.getLabel());
        radioHtml.append("\n\r</td>\n\r");
    }
    radioHtml.append("</tr>\n\r</table>");

    return radioHtml.toString();
}

public static final HttpServletRequest getOriginalRequest(HttpServletRequest request) {
    try {
    		return ((CmsFlexController)((CmsFlexRequest)request).getAttribute(CmsFlexController.ATTRIBUTE_NAME)).getTopRequest();
    } catch (ClassCastException e) {
    		return request;
    }
}

%><%
CmsFormHandler cms = new CmsFormHandler(pageContext, request, response);
CmsObject cmsObj = cms.getCmsObject();

String thisUri = cmsObj.getRequestContext().getUri();
String images = "/common/galleries/images/";
//AL 
Locale locale = new Locale(cms.property("locale", "search", "sv"));
String graphicsPath = "/system/modules/com.gridnine.opencms.ticketbrokerage.site/resources/pics";


try {
	CmsMessages messages = cms.getMessages();
	boolean showForm = true;
	CmsForm formConfig = cms.getFormConfiguration();
	
	showForm = cms.showForm();
	
	
	// Pre-check of the <select> current item. If "Select state" is still selected - 
	// show warning and return to the form.
	List fields1 = cms.getFormConfiguration().getFields();
	boolean isSelectHasErrors = false;
	for (int i = 0, n = fields1.size(); i < n; i++)
	{
		I_CmsField field = (I_CmsField)fields1.get(i);
		if ("select".equals(field.getType()) && field.isMandatory() && field.getLabel().indexOf("%%") >= 0 && ((CmsFieldItem)field.getItems().get(0)).isSelected())
		{
			isSelectHasErrors = true;
		}
	}
	// End of pre-check
	if (!isSelectHasErrors && !showForm) {
		
	    session.setAttribute("form_submitted", "true");
		                
		// try to send a notification email with the submitted form field values
			if (cms.sendMail()) {
				// successfully sent mail, show confirmation end page
				%>
				<table border="0" cellspacing="0" cellpadding="0" class="table1">
				<tr class="header1">
					<td class="space_with_arrow"><img src="<%=cms.link(graphicsPath + "/arrow.gif")%>" width="15" height="15" alt="arrow"></td>
					<td width="100%"><%= cms.getContent(thisUri,"FormConfirmationTitle",locale) %></td>
				</tr>
				<tr>
					<td colspan="2" style="padding:14px;background-color: #F5F5F5;">
				    	<%= cms.getFormConfiguration().getFormConfirmationText() %>
				    	<table cellpadding='0' cellspacing='14' border='0' style="width:100%; border:1px solid #CCCCCC;padding:0;">
						<%
						List resultList = cms.getFormConfiguration().getFields();
		
						for (int i = 0, n = resultList.size(); i < n; i++) {
							I_CmsField curField = (I_CmsField)resultList.get(i);
							if (!CmsHiddenField.class.isAssignableFrom(curField.getClass())) {
								String curFieldValue = curField.getValue();
								if ("checkbox".equals(curField.getType())){
									CmsFieldItem curFieldOption = (CmsFieldItem)curField.getItems().get(0);
									if (curFieldOption.isSelected()){
										curFieldValue = curFieldOption.getValue();
										%><tr><td valign="top" style="font-weight: bold;"><%= curField.getLabel().split("%%")[0] %></td>
										<td valign="top"><%= curFieldValue %></td></tr><%
									}									
								} else {
									%><tr><td valign="top" style="font-weight: bold;"><%= curField.getLabel().split("%%")[0] %></td>
									<td valign="top"><%= curFieldValue %></td></tr><%
								}								
							}
						}
						%>
						</table>
					</td>
				</tr>
				</table>
				<%
			} else {
				// failure sending mail, show error output %>
				<h3><%= messages.key("form.error.mail.headline") %></h3>
				<p><%= messages.key("form.error.mail.text") %></p>
	
				<%
			}
	} else {
		
		CmsForm theForm = cms.getFormConfiguration();
%>
<table border="0" cellspacing="0" cellpadding="0" class="table1">
<tr class="header1">
	<td class="space_with_arrow"><img src="<%=cms.link(graphicsPath + "/arrow.gif")%>" width="15" height="15" alt="arrow"></td>
	<td width="100%"><%= cms.getContent(thisUri,"PageTitle",locale) %></td>
</tr>
<tr class="body_all">
	<td></td>
	<td>
    <%= cms.getContent(thisUri,"PageText",locale) %>
</tr>
</table> 
		
<form
	name="feedbackForm" 
	id="feedbackForm" 
	action="<%= cms.link(cms.getRequestContext().getUri()) %>" 
	method="post" enctype="multipart/form-data" 
	class="form1">
	<input type="hidden" name="<%= cms.PARAM_FORMACTION %>" value="<%= cms.ACTION_SUBMIT %>">
	<%= theForm.getFormAttributes() %>
	
<table cellpadding="0" cellspacing="0" border="0" width="460" align="center">
<tr>
	<td class="header"><%=cms.getContent(thisUri,"FormTitle",locale) %></td>
</tr>
<tr>
	<td class="body">
		
	<table cellpadding="0" cellspacing="0" border="0" class="global">
		<tr>
			<td>
				<div class="attention" style="width:100%; text-align:left"><%
					if (cms.hasValidationErrors() || isSelectHasErrors) {
						%><%= cms.getContent(thisUri, "FormHasErrors", locale) %><%
									
						for(int i = 0, n = fields1.size(); i < n; i++) {
							I_CmsField field = (I_CmsField)fields1.get(i);
							if (field.validate(cms) != null){
								%><br><%= field.getErrorMessage() %><%
							}
						}			
					}
				%>
				</div>	
			
				<table cellpadding="0" cellspacing="0" border="0" width="100%">
				
			
		<% 
		List fields = theForm.getFields();
		int pos=0;
		int place=0;
		boolean isFormTextShown = false;
		for(int i = 0, n = fields.size(); i < n; i++) {
			I_CmsField field = (I_CmsField)fields.get(i);
			String fieldType = field.getType();	
			String fieldLabel = field.getLabel();
			String fieldName = field.getName();
			String fieldValue = field.getValue();
			
						
			%><tr><%
			
			if("select".equals(fieldType)) {
				%><td><%= buildLabelHtml(field) %></td>
				<td class="must"><% if (field.isMandatory()){ %><img src="<%=cms.link(graphicsPath + "/form_marker.gif")%>" width="5" height="23" alt="form_marker"><% } %></td>				
				<td><%= buildSelectFieldHtml(field) %></td><%
			} else if ("textarea".equals(fieldType) && !isFormTextShown) {
				isFormTextShown = true; 
				%><td><%= buildLabelHtml(field) %></td>
				<td class="must"><% if (field.isMandatory()){ %><img src="<%=cms.link(graphicsPath + "/form_marker.gif")%>" width="5" height="100" alt="form_marker"><% } %></td>
				<td><%= buildTextAreaHtml(field) %></td><%
			} else if ("checkbox".equals(fieldType)) {
             %>
             	<td><%= buildLabelHtml(field) %></td>
             	<td class="must"><% if (field.isMandatory()){ %><img src="<%=cms.link(graphicsPath + "/form_marker.gif")%>" width="5" height="23" alt="form_marker"><% } %></td>
             	<td><%= buildCheckboxHtml(field) %></td><%
         	} else if ("radio".equals(fieldType)) {
             %>
             	<td><%= buildLabelHtml(field) %></td>
             	<td class="must"><% if (field.isMandatory()){ %><img src="<%=cms.link(graphicsPath + "/form_marker.gif")%>" width="5" height="23" alt="form_marker"><% } %></td>
             	<td><%= buildRadioHtml(field) %></td><%
         	} else {
				%><td><%= buildLabelHtml(field) %></td>
				<td class="must"><% if (field.isMandatory()){ %><img src="<%=cms.link(graphicsPath + "/form_marker.gif")%>" width="5" height="23" alt="form_marker"><% } %></td>
				<td><%= buildTextFieldHtml(field) %></td><%
			}
				
			%></tr><%
		}
		%>	
						</table>
			</td>
		</tr>
	</table>
	</td> <!-- EOF td class="body" -->
</tr>
<tr>
	<td align="right">
		<table cellpadding="0" cellspacing="0" border="0" class="button1">
				<tr>
					<td class="left">&nbsp;</td>
					<td class="center"><a href="javascript:document.getElementById('feedbackForm').submit();" title="<%= cms.getContent(thisUri, "FormSubmitButton", locale) %>"><%= cms.getContent(thisUri, "FormSubmitButton", locale) %></a></td>
					<td class="right">&nbsp;</td>
				</tr>
		</table>
	</td>
</tr>
</table>
</form>

<%
	}
} catch (Throwable e) {
	out.print(e);
	e.printStackTrace(new java.io.PrintWriter(out));
	out.print("The form has wrong configuration.");
}
%>
