<%@ page pageEncoding="UTF-8" %><%
/*****************************************************************
* Gridnine AB http://www.gridnine.com
* Project: Ticket Brokerage
* $Source: $ 
* $Author: $ 
* $Date: $ 
* $Revision: $
* Legal notice: (c) Gridnine AB. All rights reserved.
*****************************************************************/
%><%@ page session = "true"
	import="org.opencms.jsp.CmsJspActionElement"
	import="org.opencms.flex.*" 
	import="java.util.*"
	import="java.text.*"
	import="com.gridnine.ticketbrokerage.*"
%><%!
private static final SimpleDateFormat formatterDate = new SimpleDateFormat("dd MMM yyyy");
private static final SimpleDateFormat formatterTime = new SimpleDateFormat("HH:mm");

private static final HttpServletResponse getOriginalResponse(HttpServletRequest request, HttpServletResponse response) {
	try {
		return ((CmsFlexController)((CmsFlexRequest)request).getAttribute(CmsFlexController.ATTRIBUTE_NAME)).getTopResponse();
	} catch (ClassCastException e) {
		return response;
	}
}

private static final String getPageTitleByEventDateID(String buyTitle, String priceFromPerTicket, String edid, Locale locale){
	EventDate eventDate = (EventDate)Manager.getPersistentObjectByUid(EventDate.class, edid); 
	String eventName = eventDate.getEvent().getName();
	if (!"".equals(eventDate.getDescription())) {
		eventDate.getEvent().getName().concat(" - ").concat(eventDate.getDescription());
	}
	String minPrice = new PricesFormat().format(Manager.getMinTicketPrice(eventDate), locale);
	Venue v = eventDate.getVenue();
	String venue = v.getName() + ", " + v.getCountry().getName() + ", " + v.getCity();
	String date = formatterTime.format(eventDate.getDate()) + ", " + formatterDate.format(eventDate.getDate());
	
	String formattedString = buyTitle + eventName;
	if (Manager.getMinTicketPrice(eventDate) != null) formattedString = formattedString + " " +  priceFromPerTicket.replaceAll("\\$\\{price\\}",minPrice) + " ";
	else formattedString = formattedString + " - ";
	formattedString = formattedString + venue + ", " + date;
	
	return formattedString; 
}

private static final String getPageTitleBySodvID(String buyTitle, String priceFromPerTicket, String sodvid, Locale locale){
    try {
        SellOrderDetailsVersion sodv = (SellOrderDetailsVersion)Manager.getPersistentObjectByUid(SellOrderDetailsVersion.class,sodvid);
	    EventDate eventDate = sodv.getEventDate();
	    return getPageTitleByEventDateID(buyTitle, priceFromPerTicket, eventDate.getUid(),locale);
    } catch (Exception e) {
        return "";
    }
}

private static final String getPageTitleByPtaID(String buyTitle, String priceFromPerTicket, String ptaid, Locale locale){
	PurchaseTransaction pta = (PurchaseTransaction)Manager.getPersistentObjectByUid(PurchaseTransaction.class,ptaid);
	EventDate eventDate = pta.getSellOrderDetailsVersion().getEventDate();
	return getPageTitleByEventDateID(buyTitle, priceFromPerTicket, eventDate.getUid(), locale);
}
%><%

try {

HttpServletResponse res = (HttpServletResponse)getOriginalResponse(request,response);
res.setHeader("Pragma", "no-cache");
res.setHeader("Cache-Control", "no-store");

request.setAttribute("navigation", "../elements/navigation.jsp");
request.setAttribute("navigation_top", "../elements/navigation_top.jsp");
request.setAttribute("navigation_bar", "");

CmsJspActionElement cms = new CmsJspActionElement(pageContext, request, response);

String labels = "/system/modules/com.gridnine.opencms.ticketbrokerage.site/resources/xml/buy_ticket.xml";
String labelsSell = "/system/modules/com.gridnine.opencms.ticketbrokerage.site/resources/xml/buy_breadcrumbs.xml";

Locale locale = new Locale(cms.property("locale","search"));
String lang = locale.toString();

String buyTitle = cms.getContent(labels, "BuyPageTitle", locale);
String priceFromPerTicket = cms.getContent(labels,"PriceFromPerTicket",locale);

int currentPage = 0;
String contentPage;

	try
	{
		currentPage = Integer.parseInt((String)request.getParameter("page"));
	}
	catch(Exception e)
	{
		currentPage = 0;
	}

	switch (currentPage){
	case 0:
		contentPage = "../elements/buy_events.jsp";
		request.setAttribute("navigation_exact", cms.getContent(labelsSell,"BuyEventsBreadcrumb",locale));
		break;
	case 1:
		contentPage = "../elements/buy_event.jsp";
		request.setAttribute("pageTitle",getPageTitleByEventDateID(buyTitle, priceFromPerTicket, (String)request.getParameter("edid"),locale));
		request.setAttribute("navigation_exact",cms.getContent(labelsSell,"BuyEventBreadcrumb",locale));
		break;
	case 2:
		contentPage = "../elements/buy_shipping_single_page.jsp";
		request.setAttribute("pageTitle",getPageTitleBySodvID(buyTitle, priceFromPerTicket,(String)request.getParameter("sodvid"),locale));
		request.setAttribute("navigation_exact", cms.getContent(labelsSell,"BuyShippingBreadcrumb",locale));
		request.setAttribute("hideFooter","true");
		break;
	case 3:
		contentPage = "../elements/buy_billing.jsp";
		request.setAttribute("navigation_exact", cms.getContent(labelsSell,"BuyBillingBreadcrumb",locale));
		break;
	case 4:
		contentPage = "../elements/buy_confirmation.jsp";
		request.setAttribute("pageTitle",getPageTitleByPtaID(buyTitle, priceFromPerTicket, (String)request.getParameter("ptaid"),locale));
		request.setAttribute("navigation_exact", cms.getContent(labelsSell,"BuyConfirmationBreadcrumb",locale));
		break;
	case 5:
		contentPage = "../elements/buy_end.jsp";
		request.setAttribute("pageTitle",getPageTitleByPtaID(buyTitle, priceFromPerTicket, (String)request.getParameter("ptaid"),locale));
		request.setAttribute("navigation_exact", cms.getContent(labelsSell,"BuyEndBreadcrumb",locale));
		break;
	case 6:
		contentPage = "../elements/buy_events_withtickets.jsp";
		request.setAttribute("navigation_exact", cms.getContent(labelsSell,"BuyEventsWithTicketsBreadcrumb",locale));
		break;
	case 10:
		contentPage = "../elements/buy_eventdates.jsp";
		request.setAttribute("navigation_exact", cms.getContent(labelsSell,"BuyEventDatesBreadcrumb",locale));
		break;
	default:
		contentPage = "../elements/buy_events.jsp";
		request.setAttribute("navigation_exact", cms.getContent(labelsSell,"BuyEventsBreadcrumb",locale));
		break;
	}

request.setAttribute("content", contentPage);

if (currentPage == 2) {
 cms.include("../frametemplates/checkout.jsp");
} else {
 cms.include("../frametemplates/standard.jsp");
}

} catch (Exception e) {
	e.printStackTrace(new java.io.PrintWriter(out));
}

%>