<%@ page pageEncoding="UTF-8" %><%@page buffer="none"
        import="java.util.*"%><%


class CountryTranslator {
    private SortedSet countryOrdering;
    private Map countriesTranslated;
    private String lang;

    public CountryTranslator(String lang) {
        SortedSet<String> countryOrdering = new TreeSet<String>();
        Map<String, String> countriesTranslated = new HashMap<String, String>();
        
        this.lang = lang;

        if (lang.equals("dk")) {
            countriesTranslated.put("Belgien", "Belgien");
            countriesTranslated.put("Bulgarien", "Bulgarien");
            countriesTranslated.put("Canada", "Canada");
            countriesTranslated.put("Cypern", "Cypern");
            countriesTranslated.put("Danmark", "Danmark");
            countriesTranslated.put("Estland", "Estland");
            countriesTranslated.put("Finland", "Finland");
            countriesTranslated.put("Frankrike", "Frankrig");
            countriesTranslated.put("Grekland", "Grækenland");
            countriesTranslated.put("Iceland", "Island");
            countriesTranslated.put("Irland", "Irland");
            countriesTranslated.put("Italien", "Italien");
            countriesTranslated.put("Lettland", "Letland");
            countriesTranslated.put("Litauen", "Litauen");
            countriesTranslated.put("Luxemburg", "Luxembourg");
            countriesTranslated.put("Malta", "Malta");
            countriesTranslated.put("Moldavia", "Moldavien");
            countriesTranslated.put("Nederländerna", "Nederlandene");
            countriesTranslated.put("Norge", "Norge");
            countriesTranslated.put("Polen", "Polen");
            countriesTranslated.put("Portugal", "Portugal");
            countriesTranslated.put("Rumänien", "Rumænien");
            countriesTranslated.put("Ryssland", "Rusland");
            countriesTranslated.put("Schweiz", "Schweiz");
            countriesTranslated.put("Slovakien", "Slovakiet");
            countriesTranslated.put("Slovenien", "Slovenien");
            countriesTranslated.put("Spanien", "Spanien");
            countriesTranslated.put("Storbritannien", "Storbritannien");
            countriesTranslated.put("Sverige", "Sverige");
            countriesTranslated.put("South Africa", "Sydafrika");
            countriesTranslated.put("Tjeckien", "Tjekkiet");
            countriesTranslated.put("Turkiet", "Tyrkiet");
            countriesTranslated.put("Tyskland", "Tyskland");
            countriesTranslated.put("USA", "USA");
            countriesTranslated.put("Ukraine", "Ukraine");
            countriesTranslated.put("Ungern", "Ungarn");
            countriesTranslated.put("Österrike", "Østrig");     
        }

        if (lang.equals("fi")) {
            countriesTranslated.put("Nederländerna", "Alankomaat");
            countriesTranslated.put("Belgien", "Belgia");
            countriesTranslated.put("Bulgarien", "Bulgaria");
            countriesTranslated.put("Spanien", "Espanja");
            countriesTranslated.put("South Africa", "Etelä-Afrikka");
            countriesTranslated.put("Irland", "Irlanti");
            countriesTranslated.put("Iceland", "Islanti");
            countriesTranslated.put("Storbritannien", "Iso-Britannia");
            countriesTranslated.put("Italien", "Italia");
            countriesTranslated.put("Österrike", "Itävalta");
            countriesTranslated.put("Canada", "Kanada");
            countriesTranslated.put("Grekland", "Kreikka");
            countriesTranslated.put("Cypern", "Kypros");
            countriesTranslated.put("Lettland", "Latvia");
            countriesTranslated.put("Litauen", "Liettua");
            countriesTranslated.put("Luxemburg", "Luxemburg");
            countriesTranslated.put("Malta", "Malta");
            countriesTranslated.put("Moldavia", "Moldavia");
            countriesTranslated.put("Norge", "Norja");
            countriesTranslated.put("Portugal", "Portugali");
            countriesTranslated.put("Polen", "Puola");
            countriesTranslated.put("Frankrike", "Ranska");
            countriesTranslated.put("Rumänien", "Romania");
            countriesTranslated.put("Sverige", "Ruotsi");
            countriesTranslated.put("Tyskland", "Saksa");
            countriesTranslated.put("Slovakien", "Slovakia");
            countriesTranslated.put("Slovenien", "Slovenia");
            countriesTranslated.put("Finland", "Suomi");
            countriesTranslated.put("Schweiz", "Sveitsi");
            countriesTranslated.put("Danmark", "Tanska");
            countriesTranslated.put("Turkiet", "Turkki");
            countriesTranslated.put("Tjeckien", "Tšekki");
            countriesTranslated.put("USA", "USA");
            countriesTranslated.put("Ukraine", "Ukraina");
            countriesTranslated.put("Ungern", "Unkari");
            countriesTranslated.put("Ryssland", "Venäjä");
            countriesTranslated.put("Estland", "Viro");
        }

        if (lang.equals("en")) {
            countriesTranslated.put("Belgien", "Belgium");
            countriesTranslated.put("Bulgarien", "Bulgaria");
            countriesTranslated.put("Canada", "Canada");
            countriesTranslated.put("Cypern", "Cyprus");
            countriesTranslated.put("Danmark", "Denmark");
            countriesTranslated.put("Estland", "Estonia");
            countriesTranslated.put("Finland", "Finland");
            countriesTranslated.put("Frankrike", "France");
            countriesTranslated.put("Grekland", "Greece");
            countriesTranslated.put("Iceland", "Iceland");
            countriesTranslated.put("Irland", "Ireland");
            countriesTranslated.put("Italien", "Italy");
            countriesTranslated.put("Lettland", "Latvia");
            countriesTranslated.put("Litauen", "Lithuania");
            countriesTranslated.put("Luxemburg", "Luxembourg");
            countriesTranslated.put("Malta", "Malta");
            countriesTranslated.put("Moldavia", "Moldavia");
            countriesTranslated.put("Nederländerna", "Holland");
            countriesTranslated.put("Norge", "Norway");
            countriesTranslated.put("Polen", "Poland");
            countriesTranslated.put("Portugal", "Portugal");
            countriesTranslated.put("Rumänien", "Romania");
            countriesTranslated.put("Ryssland", "Russia");
            countriesTranslated.put("Schweiz", "Switzerland");
            countriesTranslated.put("Slovakien", "Slovakia");
            countriesTranslated.put("Slovenien", "Slovenia");
            countriesTranslated.put("South Africa", "South Africa");
            countriesTranslated.put("Spanien", "Spain");
            countriesTranslated.put("Storbritannien", "UK");
            countriesTranslated.put("Sverige", "Sweden");
            countriesTranslated.put("Tjeckien", "Czech Republic");
            countriesTranslated.put("Turkiet", "Turkey");
            countriesTranslated.put("Tyskland", "Germany");
            countriesTranslated.put("USA", "USA");
            countriesTranslated.put("Ukraine", "Ukraine");
            countriesTranslated.put("Ungern", "Hungary");
            countriesTranslated.put("Österrike", "Austria");     
        }

        if (lang.equals("no")) {
            countriesTranslated.put("Belgien", "Belgia");
            countriesTranslated.put("Bulgarien", "Bulgaria");
            countriesTranslated.put("Canada", "Canada");
            countriesTranslated.put("Cypern", "Kypros");
            countriesTranslated.put("Danmark", "Danmark");
            countriesTranslated.put("Estland", "Estland");
            countriesTranslated.put("Finland", "Finland");
            countriesTranslated.put("Frankrike", "Frankrike");
            countriesTranslated.put("Grekland", "Hellas");
            countriesTranslated.put("Iceland", "Island");
            countriesTranslated.put("Irland", "Irland");
            countriesTranslated.put("Italien", "Italia");
            countriesTranslated.put("Lettland", "Latvia");
            countriesTranslated.put("Litauen", "Litauen");
            countriesTranslated.put("Luxemburg", "Luxembourg");
            countriesTranslated.put("Malta", "Malta");
            countriesTranslated.put("Moldavia", "Moldavia");
            countriesTranslated.put("Nederländerna", "Holland");
            countriesTranslated.put("Norge", "Norge");
            countriesTranslated.put("Polen", "Polen");
            countriesTranslated.put("Portugal", "Portugal");
            countriesTranslated.put("Rumänien", "Romania");
            countriesTranslated.put("Ryssland", "Russland");
            countriesTranslated.put("Schweiz", "Sveits");
            countriesTranslated.put("Slovakien", "Slovakia");
            countriesTranslated.put("Slovenien", "Slovenia");
            countriesTranslated.put("South Africa", "Sør-Afrika");
            countriesTranslated.put("Spanien", "Spaina");
            countriesTranslated.put("Storbritannien", "Storbritannia");
            countriesTranslated.put("Sverige", "Sverige");
            countriesTranslated.put("Tjeckien", "Tsjekkia");
            countriesTranslated.put("Turkiet", "Tyrkia");
            countriesTranslated.put("Tyskland", "Tyskland");
            countriesTranslated.put("USA", "USA");
            countriesTranslated.put("Ukraine", "Ukraina");
            countriesTranslated.put("Ungern", "Ungarn");
            countriesTranslated.put("Österrike", "Østerrike");     
        }

        this.countriesTranslated = countriesTranslated;

        if (lang.equals("sv")) {
            countryOrdering.add("Belgien");
            countryOrdering.add("Bulgarien");
            countryOrdering.add("Canada");
            countryOrdering.add("Cypern");
            countryOrdering.add("Danmark");
            countryOrdering.add("Estland");
            countryOrdering.add("Finland");
            countryOrdering.add("Frankrike");
            countryOrdering.add("Grekland");
            countryOrdering.add("Iceland");
            countryOrdering.add("Irland");
            countryOrdering.add("Italien");
            countryOrdering.add("Lettland");
            countryOrdering.add("Litauen");
            countryOrdering.add("Luxemburg");
            countryOrdering.add("Malta");
            countryOrdering.add("Moldavia");
            countryOrdering.add("Nederländerna");
            countryOrdering.add("Norge");
            countryOrdering.add("Polen");
            countryOrdering.add("Portugal");
            countryOrdering.add("Rumänien");
            countryOrdering.add("Ryssland");
            countryOrdering.add("Schweiz");
            countryOrdering.add("Slovakien");
            countryOrdering.add("Slovenien");
            countryOrdering.add("Spanien");
            countryOrdering.add("Storbritannien");
            countryOrdering.add("Sverige");
            countryOrdering.add("South Africa");
            countryOrdering.add("Tjeckien");
            countryOrdering.add("Turkiet");
            countryOrdering.add("Tyskland");
            countryOrdering.add("USA");
            countryOrdering.add("Ukraine");
            countryOrdering.add("Ungern");
            countryOrdering.add("Österrike");
        } else {
            for (String country : countriesTranslated.values()) {
                countryOrdering.add(country);
            }
        }

        this.countryOrdering = countryOrdering;
    }

    public SortedSet getCountryOrdering() {
        return this.countryOrdering;
    }

    public List getCountryOrderingInSwedish() {
        List countryOrderingInSwedish = new ArrayList();
        Iterator it = this.countryOrdering.iterator();

        while (it.hasNext()) {
            String country = (String) it.next();

            if (this.lang.equals("sv")) {
                countryOrderingInSwedish.add(country);
            } else { 
                for (Iterator it2 = this.countriesTranslated.keySet().iterator(); it2.hasNext();) {
                    String key = (String) it2.next();
                    String value = (String) this.countriesTranslated.get(key);

                    if (country.equals(value)) {
                        countryOrderingInSwedish.add(key);
                    }
                }
            }
        }

        return countryOrderingInSwedish;
    }

    public String getTranslation(String country) {
        // languages are keyed by swedish - no translation necessary
        if (this.lang.equals("sv")) { return country; }

        String countryTranslated = null;

        try {
            countryTranslated = (String) countriesTranslated.get(country);
        } catch (Exception e) {
            // translation not found - return original country name
            countryTranslated = country;
        }

        return countryTranslated;
    }

    public String getKey(String country) {
        if (this.lang.equals("sv")) {
            return country;
        }

        String foundKey = country;

        // filter countriesTranslated by translated country name to get key

        for (Iterator it = this.countriesTranslated.keySet().iterator(); it.hasNext();) {
            String key = (String) it.next();
            String value = (String) this.countriesTranslated.get(key);

            if (country.equals(value)) {
                foundKey = key;
            }
        }

        return foundKey;
    }
    
    public String getTranslation(String country, String lang) {
        // languages are keyed by swedish - no translation necessary
        if (lang.equals("sv")) { return country; }

        String countryTranslated = null;

        try {
            countryTranslated = (String) countriesTranslated.get(country);
        } catch (Exception e) {
            // translation not found - return original country name
            countryTranslated = country;
        }

        return countryTranslated;
    }
}


%>